#include <iostream>
#include <vector>
#include <cctype>
#include <utility>

#include "nsUtil.h"

using namespace std;
using namespace nsUtil;
string & ToUpper (string & Str)
{
    for (char & car : Str)
        car = toupper (car);
    return  Str;
}

vector <string> & ToUpper (vector <string> & VString)
{
    for (string & str : VString)
        str = ToUpper(str);
    return VString;
}

vector <string> & ToUpper (vector <string> & VString, const unsigned & LineNumber)
{
    ToUpper(VString [LineNumber]);
    return VString;
}

string & ToLower (string & Str)
{
    for (char & car : Str)
        car = tolower (car);
    return  Str;
}

vector <string> & ToLower (vector <string> & VString)
{
    for (string & str : VString)
        str = ToLower (str);
    return VString;
}

vector <string> & ToLower (vector <string> & VString, const unsigned & LineNumber)
{
    ToLower (VString [LineNumber]);
    return VString;
}

string & TrimLeft (string & Str)
{
    unsigned Pos (0);
    for (; Pos < Str.size() && isspace (Str[Pos]); ++ Pos);
    for (unsigned i (0); i < Str.size()- Pos; ++i) Str[i] = Str[i + Pos];
    Str.resize(Str.size()-Pos);
    return Str;
}

vector <string> & TrimLeft (vector <string> & VString, const unsigned & LineNumber)
{
    TrimLeft (VString [LineNumber]);
    return VString;
}

vector <string> & TrimLeft (vector <string> & VString)
{
    for (string & str : VString)
        str = TrimLeft (str);
    return VString;
}

string & TrimRight (string & Str, const unsigned long & Width)
{
    if (Width < Str.size()) return Str;
    unsigned long OldSize (Str.size());

    Str.resize (Width);
    for (unsigned i (OldSize), j (Width - 1); i -- > 0; ) Str[j--] = Str [i];
    for (unsigned i (0); i < Width - OldSize; ++i) Str [i] = ' ';

    return Str;
}

vector <string> & TrimRight (vector <string> & VString, const unsigned & LineNumber, const unsigned long & Width)
{
    TrimRight (VString [LineNumber], Width);
    return VString;
}

vector <string> & TrimRight (vector <string> & VString, const unsigned long & Width)
{
    for (string & str : VString)
        str = TrimRight (str, Width);
    return VString;
}

string & Center (string & Str, const unsigned long & Width)
{
    if (Width < Str.size()) return Str;
    unsigned long Delta (Width - Str.size());

    Str = string (Delta / 2 + ((Delta % 2 == 0) ?  0 : 1), ' ') + Str + string (Delta/2, ' ');
    return Str;
}


vector <string> & Center (vector <string> & VString, const unsigned & LineNumber, const unsigned long & Width)
{
    Center (VString [LineNumber], Width);
    return VString;
}

vector <string> & Center (vector <string> & VString, const unsigned long & Width)
{
    for (string & str : VString)
        str = Center (str, Width);
    return VString;
}

vector <string> & Delete (vector <string> & VString, const unsigned & PosBeg)
{
    for (unsigned i (PosBeg); i < VString.size() - 1; ++i )
        VString [i] = VString [i + 1];
    VString.resize(VString.size() - 1);
    return VString;
}

vector <string> & Swap (vector <string> & VString, const unsigned & PosBeg, const unsigned & PosEnd)
{
    swap (VString[PosBeg], VString[PosEnd]);
    return VString;
}

vector <string> & Insert (vector <string> & VString, const unsigned & PosBeg, const string & Line)
{
    VString.resize(VString.size() + 1);
    for (unsigned i (VString.size()-1); i -- > PosBeg; )
        VString [i+1] = VString [i];
    VString[PosBeg] = Line;
    return VString;
}

vector <string> & Move (vector <string> & VString, const unsigned & PosBeg, const unsigned & PosEnd)
{
    if (PosBeg < PosEnd)
    {
        VString = Insert (VString, PosEnd + 1,VString [PosBeg]);
        VString = Delete (VString, PosBeg);
    }
    else
    {
        VString = Insert (VString, PosEnd, VString [PosBeg]);
        VString = Delete (VString, PosBeg + 1);
    }
    return VString;
}

string & Justify (string & Str, const unsigned long & Width)
{
    unsigned NbCar (0), NbInterv (0);

    for (unsigned i (0); i < Str.size(); ++i)
    {
        if (isspace((Str[i])))
        {
            Str [NbCar] = ' ';
            ++NbCar;
            ++NbInterv;
        }
        else
        {
            Str[NbCar] = Str [i];
            ++ NbCar;
        }
    }
    if (NbCar > 0  && Str [NbCar - 1] == ' ')
    {
        --NbCar;
        --NbInterv;
    }
    if (0 == NbInterv) return Str;

    unsigned NbSpacesToAdd (Width - NbCar);
    unsigned NbSpaces (NbSpacesToAdd / NbInterv);
    unsigned Where (Str.find (' ', 0));
    for (unsigned i (0); i < NbSpacesToAdd % NbInterv; ++i)
    {
        Str.insert(Where, NbSpaces + 1, ' ');
        Where = Str.find(' ', Where  + 2 + NbSpaces);
    }
    for (unsigned i (NbSpacesToAdd % NbInterv); i < NbInterv; ++i)
    {
        Str.insert(Where, NbSpaces, ' ');
        Where = Str.find(' ', Where  + 1 + NbSpaces);
    }
    return Str;
}

vector <string> & Justify (vector <string> & VString, const unsigned & LineNumber, const unsigned long & Width)
{
    Justify (VString [LineNumber], Width);
    return VString;
}

vector <string> & Justify (vector <string> & VString, const unsigned long & Width)
{
    for (string & str : VString)
        str = Justify (str, Width);
    return VString;
}

string & Trim (string & Str)
{
    Str = TrimLeft (Str);
    unsigned Pos (Str.size());
    for (;Pos-- >0 && isspace (Str[Pos]););
    Str.resize(Pos == 0 ? 0 : Pos + 1);
    return Str;
}

vector <string> & Trim (vector <string> & VString, const unsigned & LineNumber)
{
    Trim (VString [LineNumber]);
    return VString;
}

vector <string> & Trim (vector <string> & VString)
{
    for (string & str : VString)
        str = Trim (str);
    return VString;
}

string & RemoveMultipleSpaces (string & Str)
{
    for (unsigned i (0); i < Str.size(); ++i)
    {
        if (!isspace(Str[i])) continue;
        unsigned j(i + 1);
        while (j < Str.size () && isspace (Str[j])) ++j;
        Str.erase (i + 1, j-i-1);
    }
    return Str;
}

vector <string> & RemoveMultipleSpaces (vector <string> & VString, const unsigned & LineNumber)
{
    RemoveMultipleSpaces (VString [LineNumber]);
    return VString;
}

vector <string> & RemoveMultipleSpaces (vector <string> & VString)
{
    for (string & str : VString)
        str = RemoveMultipleSpaces (str);
    return VString;
}

string ToLeet (char c)
{
    unsigned NbIter  = tolower(c) - 'a';
    unsigned PosBeg (0);
    for (unsigned i (0); i < NbIter; ++i)
    {
        PosBeg = KLeet.find(',', PosBeg) + 1;
    }
    unsigned PosEnd = KLeet.find(',', PosBeg);
    return KLeet.substr(PosBeg, PosEnd-PosBeg);
}

string & ToLeet (string & Str)
{
    for (unsigned i (0); i < Str.size(); )
    {
        if (isalpha(Str[i]))
        {
            string ToReplace = ToLeet(Str[i]);
            Str.replace(i, 1, ToReplace);
            i += ToReplace.size();
        }
        else ++i;
    }
    return Str;
}


vector <string> & ToLeet (vector <string> & VString, const unsigned & LineNumber)
{
    ToLeet (VString [LineNumber]);
    return VString;
}

vector <string> & ToLeet (vector <string> & VString)
{
    for (string & str : VString)
        str = ToLeet (str);
    return VString;
}

int main(int argc, char *argv[])
{
    if (3 != argc)
    {
        cerr << "gros boulet" << endl;
        exit (0);
    }

    string InputFile (argv[1]);
    unsigned long Width (stoul(argv[2]));
    vector <string> VFile (FileToVectString (InputFile));
    EditVStringV3 (VFile);
    string Instruction, Complement;
    while (true)
    {
        cin >> Instruction;
        Instruction = ToLower (Instruction);
        if ("fin" == Instruction)
        {
            break;
        }
        //sauvergarde
        else if ("sav" == Instruction)
        {
            string FileOut;
            cin >> FileOut;
            VectStringToFile (VFile, FileOut);

        }
        //majuscule
        else if ( "maj" ==  Instruction)
        {
            cin >> Complement;
            if (ToLower(Complement) == "tout")
                ToUpper (VFile);
            else
                ToUpper (VFile, stoul(Complement));
        }
        //minuscule
        else if ( "min" ==  Instruction)
        {
            cin >> Complement;
            if (ToLower (Complement) == "tout")
                ToLower (VFile);
            else
                ToLower (VFile, stoul(Complement));
        }
        //trim left
        else if ( "tl" ==  Instruction)
        {
            cin >> Complement;
            if (ToLower(Complement) == "tout")
                TrimLeft (VFile);
            else
                TrimLeft (VFile, stoul(Complement));

        }
        //trim right
        else if ( "tr" ==  Instruction)
        {
            cin >> Complement;
            if (ToLower(Complement) == "tout")
                TrimRight (VFile, Width);
            else
                TrimRight (VFile, stoul(Complement), Width);

        }
        //center
        else if ( "cen" ==  Instruction)
        {
            cin >> Complement;
            if (ToLower(Complement) == "tout")
                Center (VFile, Width);
            else
                Center (VFile, stoul(Complement), Width);
        }
        //swap
        else if ( "swa" ==  Instruction)
        {
            unsigned PosDep, PosEnd;
            cin >> PosDep >> PosEnd;
            Swap (VFile, PosDep, PosEnd);
            break;
        }
        //insertion
        else if ( "ins" ==  Instruction)
        {
            unsigned PosDep;
            string Line;
            cin >> PosDep;
            getline (cin, Line);
            Insert (VFile, PosDep, Line);
        }
        //delete
        else if ( "del" ==  Instruction)
        {
            unsigned PosDep;
            cin >> PosDep;
            Delete (VFile, PosDep);

        }
        //deplacement
        else if ( "mov" ==  Instruction)
        {
            unsigned PosDep, PosEnd;
            cin >> PosDep >> PosEnd;
            Move (VFile, PosDep, PosEnd);

        }
        //justification
        else if ( "jus" ==  Instruction)
        {
            cin >> Complement;
            if (ToLower(Complement) == "tout")
                Justify (VFile, Width);
            else
                Justify (VFile, stoul(Complement), Width);
        }
        //suppression des espaces inutiles en debut et en fin de ligne
        else if ("tri" == Instruction)
        {
            cin >> Complement;
            if (ToLower(Complement) == "tout")
                Trim (VFile);
            else
                Trim (VFile, stoul(Complement));
        }
        //supression des espaces multiples
        else if ("mul" == Instruction)
        {
            cin >> Complement;
            if (ToLower(Complement) == "tout")
                RemoveMultipleSpaces (VFile);
            else
                RemoveMultipleSpaces (VFile, stoul(Complement));
        }
        else if ("lee" == Instruction)
        {
            cin >> Complement;
            if (ToLower(Complement) == "tout")
                ToLeet (VFile);
            else
                ToLeet (VFile, stoul(Complement));
        }
        else if ("int" == Instruction)
        {
            EditVStringV4 (VFile);
        }
        EditVStringV2 (VFile);
    }//while

    return 0;
}

